/* Data Files header for Services.
 *
 * Magick IRC Services are copyright (c) 1996-1998 Preston A. Elder.
 *     E-mail: <prez@magick.tm>   IRC: PreZ@RelicNet
 * Originally based on EsperNet services (c) 1996-1998 Andy Church
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

 
/****************************************************************************
 * nick.db
 ****************************************************************************/
typedef struct m_nickinfo_ m_NickInfo;
typedef struct m_chaninfo_ m_ChanInfo;
typedef struct m_chanaccess_ m_ChanAccess;
typedef struct m_autokick_ m_AutoKick;

struct m_nickinfo_ {
    NickInfo *next, *prev;
    char nick[NICKMAX];
    char pass[PASSMAX];
    char *email;
    char *url;
    char *last_usermask;
    char *last_realname;
    time_t time_registered;
    time_t last_seen;
    long accesscount;	/* # of entries */
    char **access;	/* Array of strings */
    long ignorecount;   /* # of entries */
    char **ignore;	/* Array of strings */
    long flags;		/* See below */
    long reserved[4];	/* For future expansion -- set to 0 */
};

/****************************************************************************
 * chan.db
 ****************************************************************************/

struct m_chanaccess_ {
    short level;
    short is_nick;	/* 1 if this is a nick, 0 if a user@host mask.  If
			 * -1, then this entry is currently unused (a hack
			 * to get numbered lists to have consistent
			 * numbering). */
    char *name;
};

struct m_autokick_ {
    short is_nick;
    short pad;
    char *name;
    char *reason;
};


struct m_chaninfo_ {
    ChannelInfo *next, *prev;
    char name[CHANMAX];
    char founder[NICKMAX];		/* Always a reg'd nick */
    char founderpass[PASSMAX];
    char *desc;
    char *url;
    time_t time_registered;
    time_t last_used;
    long accesscount;
    m_ChanAccess *access;			/* List of authorized users */
    long akickcount;
    m_AutoKick *akick;
    char mlock_on[64], mlock_off[64];	/* See channel modes below */
    long mlock_limit;			/* 0 if no limit */
    char *mlock_key;			/* NULL if no key */
    char *last_topic;			/* Last topic on the channel */
    char last_topic_setter[NICKMAX];	/* Who set the last topic */
    time_t last_topic_time;		/* When the last topic was set */
    long flags;				/* See below */
    short *cmd_access;			/* Access levels for commands */
    long reserved[3];			/* For future expansion -- set to 0 */
};

